{$APPTYPE CONSOLE}
{$MAXSTACKSIZE 32000000}

uses SysUtils, Math;

const MaxN = 1000;

type TLong = array[0..4*MaxN] of integer;

var x1, x2, x3, x4, y1, y2, y3, y4, ans, tmp: TLong;
    i, j, k, l, n, m: integer;
    s: string;
    fi, fo: text;

function LongConvert(var s: string): Tlong;
var i, r: integer;
begin
  FillChar(Result, SizeOf(Result), 0);
  r := length(s); Result[0] := r;
  if s[1] = '-' then begin dec(r); Result[0] := -Result[0] + 1; s := copy(s, 2, r); end;
  for i := r downto 1 do
    begin
      Result[r-i+1] := strtoint(s[i]);
    end;
end;                                 

procedure LongWrite(var a: TLong);
var i, l: integer;
begin
  l := abs(a[0]);
  if a[0] < 0 then write(fo, '-');
  for i := l downto 1 do
    begin
      write(fo, a[i]);
    end;
  if l = 0 then write(fo, 0);
  writeln(fo);
end;

function LongEqual(var a, b: Tlong): boolean;
var i, k: integer;
begin
  if a[0] <> b[0] then begin Result := false; exit; end else Result := true;
  k := abs(a[0]);
  for i := 1 to k do
    begin
      if a[i] <> b[i] then begin Result := false; exit; end;
    end;
end;

function LongLessThan(var a, b: TLong): boolean;
var i, k: integer;
begin
  if (a[0] <> b[0]) then begin Result := (a[0] < b[0]); exit; end else Result := false;
  k := abs(a[0]);
  for i := k downto 1 do
    begin
      if a[i] <> b[i] then
        begin
          Result := ((a[i] > b[i]) xor (a[0] > 0)); exit;
        end;
    end;
end;

function LongLessEqual(var a, b: TLong): boolean;
begin
  Result := (LongLessThan(a, b) or (LongEqual(a, b)));
end;

function LongMoreThan(var a, b: TLong): boolean;
var i, k: integer;
begin
  if (a[0] <> b[0]) then begin Result := (a[0] > b[0]); exit; end else Result := false;
  k := abs(a[0]);
  for i := k downto 1 do
    begin
      if a[i] <> b[i] then
        begin
          Result := ((a[i] < b[i]) xor (a[0] > 0)); exit;
        end;
    end;
end;

function LongMoreEqual(var a, b: TLong): boolean;
begin
  Result := (LongMoreThan(a, b) or (LongEqual(a, b)));
end;

procedure LongNormalization(var a: TLong);
var i: integer;
begin
  for i := 1 to a[0] do
    begin
      if a[i] < 0 then
        begin
          dec(a[i+1]);
          a[i] := 10 + a[i];
        end;
      if a[i] >= 10 then
        begin
          inc(a[i+1]);
          a[i] := a[i] - 10 ;
        end;
    end;
  for i := a[0]+2 downto 1 do
    begin
      if (a[i] = 0) and (a[i-1] <> 0) then
        begin
          a[0] := i-1;
          break;
        end;
    end
end;

function LongSumm(var a, b: TLong): TLong;
var k: integer;
    pa, pb, pr: boolean;

  function Sum(var a, b: TLong; sum: boolean): Tlong;
  var i: integer;
  begin
    FillChar(Result, SizeOf(Result), 0);
    Result[0] := k;
    for i := 1 to k do
      begin
        if sum then Result[i] := a[i] + b[i]
        else Result[i] := a[i] - b[i];
      end;
    LongNormalization(Result);
  end;

begin
  FillChar(Result, SizeOf(Result), 0);
  pa := (a[0] >= 0); pb := (b[0] >= 0);
  a[0] := abs(a[0]);  b[0] := abs(b[0]);
  k := max(a[0], b[0]);
  Result[0] := k;
  if not (pa xor pb) then
    begin
      Result := Sum(a, b, true);
      pr := pa;
    end
  else
    begin
      if LongLessThan(a, b) then
        begin
          Result := sum(b, a, false);
          pr := pb;
        end
      else
        begin
          Result := sum(a, b, false);
          pr := pa;
        end;
    end;
  if not pa then a[0] := -a[0];
  if not pb then b[0] := -b[0];
  if not pr then Result[0] := -Result[0];
end;

function LongDiff(var a: TLong; b: Tlong): Tlong;
begin
  b[0] := -b[0];
  Result := LongSumm(a, b);
end;

function LongMult(var a, b: Tlong): Tlong;
var i, j, ka, kb: integer;
    ok: boolean;
    tmp: TLong;
begin
  FillChar(Result, SizeOf(Result), 0);
  ka := abs(a[0]); kb := abs(b[0]);
  for i := 1 to ka do
    begin
      FillChar(tmp, SizeOf(tmp), 0);
      for j := 1 to kb do
        begin
          tmp[i+j-1] := tmp[i+j-1] + a[i] * b[j];
          if tmp[i+j-1] >= 10 then
            begin
              tmp[i+j] := tmp[i+j-1] div 10;
              tmp[i+j-1] := tmp[i+j-1] mod 10;
            end;
        end;
      ok := false; j := i + j + 1 ;
      while (tmp[j] = 0) and (j > 0) do dec(j);
      while tmp[j] >= 10 do
        begin
          tmp[j+1] := tmp[i] div 10;
          tmp[j] := tmp[j] mod 10;
          inc(j);
        end;
      tmp[0] := j;
      Result := LongSumm(Result, tmp);
    end;
  if ((a[0] >= 0) xor (b[0] >= 0)) then Result[0] := -Result[0];
end;

function Longamodb(a: TLong; var b: TLong): TLong;
var i, k, j: integer;
    tmp1, tmp2: Tlong;
begin
  k := a[0] - b[0];
  for i := k downto 0 do
    begin
      FillChar(tmp1, SizeOf(tmp1), 0);
      tmp1[0] := i + b[0];
      for j := 1 to tmp1[0] do
        begin
          tmp1[j + i] := b[j];
        end;
      while LongMoreEqual(a, tmp1) do
        begin
          a := LongDiff(a, tmp1);
          LongNormalization(a);
        end;
    end;
  Result := a;
end;

function LongDiv2(var a: TLong): TLong;
var i: integer;
begin
  Result := a;
  for i := Result[0] downto 1 do
    begin
      if Result[i] mod 2 = 1 then
        inc(Result[i-1], 10);
      Result[i] := Result[i] div 2;
    end;
  LongNormalization(Result);
end;

procedure LongSwap(var a, b: TLong);
var t: TLong;
begin
  t := a; a := b; b := t;
end;

procedure Botva;
begin
  write(fo, '-1');
  CloseFile(fi);
  CloseFile(fo);
  halt(0);
end;

function numpart(a, b: TLong): TLong;
begin
  if(LongLessThan(a, b)) then LongSwap(a, b);
  while b[0] <> 0 do
    begin
      a := Longamodb(a, b);
      LongSwap(a, b);
    end;
  Result := a;
end;

function qsquares(var a, b: TLong): TLong;
var tmp: TLong;
begin
  tmp := numpart(a, b);
  Result := LongSumm(a, b);
  Result := LongDiff(Result, tmp);
end;

function calc(var a, b: TLong): TLong;
var tmp, q: TLong;
begin
  q := qsquares(a, b);
  tmp := LongMult(a, b);
  Result := LongDiff(tmp, q);
  Result := LongDiv2(Result);
end;

begin
  AssignFile(fi, 'input.txt');
  AssignFile(fo, 'output.txt');
  reset(fi);
  rewrite(fo);
  readln(fi, s); x1 := LongConvert(s);
  readln(fi, s); y1 := LongConvert(s);
  readln(fi, s); x2 := LongConvert(s);
  readln(fi, s); y2 := LongConvert(s);
  readln(fi, s); x3 := LongConvert(s);
  readln(fi, s); y3 := LongConvert(s);
  if LongEqual(x1, x3) or LongEqual(y1, y3) then
    begin
      LongSwap(x2, x3); LongSwap(y2, y3);
    end;
  if LongEqual(x2, x3) or LongEqual(y2, y3) then
    begin
      LongSwap(x1, x3); LongSwap(y1, y3);
    end;
  if LongEqual(x1, x2) then
    begin
      LongSwap(x1, y1); LongSwap(x2, y2); LongSwap(x3, y3);
    end;
  if LongMoreThan(x1, x2) then
    begin
      LongSwap(x1, x2); LongSwap(y1, y2);
    end;
  if not LongEqual(y1, y2) then Botva;
  x2 := LongDiff(x2, x1); x3 := LongDiff(x3, x1);
  y2 := LongDiff(y2, y1); y3 := LongDiff(y3, y1);
  if y3[0] < 0 then y3[0] := -y3[0];
  if x3[0] <= 0 then
    begin
      x3 := LongDiff(x2, x3);
    end;
  if LongMoreThan(x3, x2) then Botva;
  if LongEqual(x3, x2) then
    begin
      ans := calc(x3, y3);
    end
  else
    begin
      ans := calc(x3, y3);
      x4 := LongDiff(x2, x3);
      y4 := y3;
      tmp := calc(x4, y4);
      ans := LongSumm(ans, tmp);
    end;
  LongWrite(ans);
  CloseFile(fi);
  CloseFile(fo);
end.
